 //--Audio------------------------------------------------------------------------------------------------------
datablock AudioProfile(HeadExplosionSound)
{
   filename    = "./sound/jeepExplosion.wav";
   description = AudioDefault3d;
   preload = true;
};

//--Particles------------------------------------------------------------------------
datablock ParticleData(HeadBurnParticle)
{
	textureName          = "base/data/particles/cloud";
	dragCoefficient      = 0.0;
	gravityCoefficient   = -1.0;
	inheritedVelFactor   = 0.0;
	windCoefficient      = 0;
	constantAcceleration = 3.0;
	lifetimeMS           = 1200;
	lifetimeVarianceMS   = 100;
	spinSpeed     = 0;
	spinRandomMin = -90.0;
	spinRandomMax =  90.0;
	useInvAlpha   = false;
	colors[0]	= "1   1   0.3 0.0";
	colors[1]	= "1   1   0.3 1.0";
	colors[2]	= "0.6 0.0 0.0 0.0";
	sizes[0]	= 0.0;
	sizes[1]	= 2.0;
	sizes[2]	= 1.0;
	times[0]	= 0.0;
	times[1]	= 0.2;
	times[2]	= 1.0;
};
datablock ParticleEmitterData(HeadBurnEmitter)
{
   ejectionPeriodMS = 14;
   periodVarianceMS = 4;
   ejectionVelocity = 0;
   ejectionOffset   = 1.00;
   velocityVariance = 0.0;
   thetaMin         = 30;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = HeadBurnParticle;   
};
datablock ParticleData(HeadExplosionParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= -0.5;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 1900;
	lifetimeVarianceMS	= 300;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;
	textureName		= "base/data/particles/cloud";
	colors[0]	= "0.9 0.3 0.2 0.9";
	colors[1]	= "0.0 0.0 0.0 0.0";
	sizes[0]	= 2.5;
	sizes[1]	= 5.0;
	times[0]	= 0.0;
	times[1]	= 1.0;
};
datablock ParticleEmitterData(HeadExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   lifeTimeMS	   = 21;
   ejectionVelocity = 8;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "HeadExplosionParticle";
   emitterNode = TenthEmitterNode;
};
datablock ParticleData(HeadDebrisTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= -0.5;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 600;
	lifetimeVarianceMS	= 150;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;
	textureName		= "base/data/particles/cloud";
	colors[0]	= "0.0 0.0 0.0 0.5";
	colors[1]	= "0.0 0.0 0.0 1.0";
	colors[2]	= "0.0 0.0 0.0 0.0";
	sizes[0]	= 2.0;
	sizes[1]	= 5.0;
	sizes[2]	= 5.0;
	times[0]	= 0.0;
	times[1]	= 0.1;
	times[2]	= 1.0;
};
datablock ParticleEmitterData(HeadDebrisTrailEmitter)
{
   ejectionPeriodMS = 15;
   periodVarianceMS = 0;
   ejectionVelocity = 8;
   velocityVariance = 1.0;
   ejectionOffset   = 1.0;
   thetaMin         = 40;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "HeadDebrisTrailParticle";
   emitterNode = FifthEmitterNode;
};
datablock ParticleData(HeadFinalExplosionParticle)
{
	dragCoefficient		= 1.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= -0.5;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 1900;
	lifetimeVarianceMS	= 1000;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;
	textureName		= "base/data/particles/cloud";
	colors[0]	= "0.0 0.0 0.0 0.5";
	colors[1]	= "0.0 0.0 0.0 1.0";
	colors[2]	= "0.0 0.0 0.0 0.0";
	sizes[0]	= 2.5;
	sizes[1]	= 5.0;
	sizes[2]	= 2.5;
	times[0]	= 0.0;
	times[1]	= 0.1;
	times[2]	= 1.0;
};
datablock ParticleEmitterData(HeadFinalExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   lifeTimeMS	   = 21;
   ejectionVelocity = 8;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 10;
   thetaMax         = 40;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "HeadFinalExplosionParticle";
   emitterNode = TwentiethEmitterNode;
};
datablock ParticleData(HeadSmokeParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 525;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.5 0.5 0.9";
	colors[1]     = "0.5 0.5 0.5 0.0";
	sizes[0]      = 0.15;
	sizes[1]      = 0.15;
	useInvAlpha = false;
};
datablock ParticleEmitterData(HeadSmokeEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "HeadSmokeParticle";
};

//--Textures---------------------------------------------------------------------------------------------------
datablock ParticleData(Skin){textureName = "./Models/base.blank.png";};
datablock ParticleData(MonkeyHand){textureName = "./Models/yellow.blank.jpg";};
datablock ParticleData(BearFace){textureName = "./Models/PBear.png";};
datablock ParticleData(BearEar){textureName = "./Models/pink.jpg";};

//--Models-----------------------------------------------------------------------------------------------------
datablock PlayerData(SmallAnimalArmor : HorseArmor)
{
   maxSideCrouchSpeed = 6;
   maxSideSpeed = 6;
   jumpForce = 17 * 100;
   uiname = "";
};
datablock ShapeBaseImageData(PBearImage)
{
	shapeFile = "./Models/Pedo.dts";
	emap = true;
	doColorShift = true;
	colorshiftcolor = "0.4 0.3 0.2 1";
	mountPoint = $HeadSlot;
	offset = "0 -0.04 -0.14";
	eyeOffset = "-1 -1 -1";
	rotation = "0 0 0 0";
	className = "ItemImage";
};
datablock ShapeBaseImageData(DogImage)
{
	shapeFile = "./Models/Dog.dts";
	emap = false;
	doColorShift = true;
	colorshiftcolor = "0.4 0.3 0.2 1";
	mountPoint = $BackSlot;
	offset = "0 0 -0.35";
	eyeOffset = "-1 -1 -1";
	rotation = "0 0 1 180";
	className = "ItemImage";
};
datablock ShapeBaseImageData(DogRedImage    : DogImage){colorshiftcolor = "0.900 0.000 0.000 1.000";};
datablock ShapeBaseImageData(DogBlueImage   : DogImage){colorshiftcolor = "0.200 0.000 0.800 1.000";};
datablock ShapeBaseImageData(DogPinkImage   : DogImage){colorshiftcolor = "0.900 0.400 0.700 1.000";};
datablock ShapeBaseImageData(DogGreenImage  : DogImage){colorshiftcolor = "0.000 0.500 0.250 1.000";};
datablock ShapeBaseImageData(DogWhiteImage  : DogImage){colorshiftcolor = "1.000 1.000 1.000 1.000";};
datablock ShapeBaseImageData(DogBlackImage  : DogImage){colorshiftcolor = "0.200 0.200 0.200 1.000";};
datablock ShapeBaseImageData(DogYellowImage : DogImage){colorshiftcolor = "0.900 0.900 0.000 1.000";};
datablock ShapeBaseImageData(DogOrangeImage : DogImage){colorshiftcolor = "1.000 0.500 0.000 1.000";};
datablock ShapeBaseImageData(DogPurpleImage : DogImage){colorshiftcolor = "0.500 0.000 1.000 1.000";};
datablock ShapeBaseImageData(MonkeyImage)
{
	shapeFile = "./Models/Monkey.dts";
	emap = false;
	doColorShift = True;
	colorshiftcolor = "0.4 0.3 0.2 1";
	mountPoint = $BackSlot;
	offset = "0 0 -1.6";
	eyeOffset = "-1 -1 -1";
	rotation = "0 0 1 180";
	className = "ItemImage";
};
datablock ShapeBaseImageData(MonkeyRedImage    : MonkeyImage){colorshiftcolor = "0.900 0.000 0.000 1.000";};
datablock ShapeBaseImageData(MonkeyBlueImage   : MonkeyImage){colorshiftcolor = "0.200 0.000 0.800 1.000";};
datablock ShapeBaseImageData(MonkeyPinkImage   : MonkeyImage){colorshiftcolor = "0.900 0.400 0.700 1.000";};
datablock ShapeBaseImageData(MonkeyGreenImage  : MonkeyImage){colorshiftcolor = "0.000 0.500 0.250 1.000";};
datablock ShapeBaseImageData(MonkeyWhiteImage  : MonkeyImage){colorshiftcolor = "1.000 1.000 1.000 1.000";};
datablock ShapeBaseImageData(MonkeyBlackImage  : MonkeyImage){colorshiftcolor = "0.200 0.200 0.200 1.000";};
datablock ShapeBaseImageData(MonkeyYellowImage : MonkeyImage){colorshiftcolor = "0.900 0.900 0.000 1.000";};
datablock ShapeBaseImageData(MonkeyOrangeImage : MonkeyImage){colorshiftcolor = "1.000 0.500 0.000 1.000";};
datablock ShapeBaseImageData(MonkeyPurpleImage : MonkeyImage){colorshiftcolor = "0.500 0.000 1.000 1.000";};
datablock ShapeBaseImageData(SkeleBodyImage)
{
	shapeFile = "./Models/SkeleBody.dts";
	emap = false;
	doColorShift = True;
	colorshiftcolor = "1 1 1 1";
	mountPoint = 2;
	offset = "0 .02 -1.18";
	eyeOffset = "-1 -1 -1";
};
datablock ShapeBaseImageData(SkeleHeadImage)
{
	shapeFile = "./Models/SkeleHead.dts";
	emap = false;
	doColorShift = True;
	colorshiftcolor = "1 1 1 1";
	mountPoint = 5;
	offset = "0 0 -.4";
	eyeOffset = "-1 -1 -1";
};
datablock ShapeBaseImageData(HeadExplosionImage)
{
	shapeFile = "base/data/shapes/empty.dts";
	emap = false;
	mountPoint = $BackSlot;
  	rotation = "1 0 0 -90";

	stateName[0]			= "Ready";
	stateTransitionOnTimeout[0]	= "FireA";
	stateTimeoutValue[0]		= 0.01;

	stateName[1]			= "FireA";
	stateTransitionOnTimeout[1]	= "FireB";
	stateWaitForTimeout[1]		= false;
	stateTimeoutValue[1]		= 0.1;
	stateEmitter[1]			= HeadBurnEmitter;
	stateEmitterTime[1]		= 4;

	stateName[2]			= "FireB";
	stateTransitionOnTimeout[2]	= "FireC";
	stateWaitForTimeout[2]		= false;
	stateTimeoutValue[2]		= 0.1;
	stateSound[2]			= HeadExplosionSound;
	stateEmitter[2]			= HeadExplosionEmitter;
	stateEmitterTime[2]		= 3;

	stateName[3]			= "FireC";
	stateTransitionOnTimeout[3]	= "FireD";
	stateWaitForTimeout[3]		= false;
	stateTimeoutValue[3]		= 0.1;
	stateEmitter[3]			= HeadDebrisTrailEmitter;
	stateEmitterTime[3]		= 3;

	stateName[4]			= "FireD";
	stateTransitionOnTimeout[4]	= "FireE";
	stateWaitForTimeout[4]		= false;
	stateTimeoutValue[4]		= 0.1;
	stateEmitter[4]			= HeadFinalExplosionEmitter;
	stateEmitterTime[4]		= 1;


	stateName[5]			= "FireE";
	stateTransitionOnTimeout[5]	= "Done";
	stateWaitForTimeout[5]		= false;
	stateTimeoutValue[5]		= 4.1;
	stateEmitter[5]			= HeadSmokeEmitter;
	stateEmitterTime[5]		= 4;

	stateName[6]			="Done";
	stateScript[6]			="onDone";
};

//--Commands----------------------------------------------------------------------------------------------------
function HeadExplosionImage::onDone(%this,%obj,%slot){%obj.unMountImage(%slot);}

function NinjaPoofImage::onDone(%this,%obj,%slot){%obj.unMountImage(%slot);}

function cacheAvatarColor(%Client)
{
		%Client.hatColor2 = %Client.hatColor;
		%Client.headcolor2 = %Client.headColor;
		%Client.accentColor2 = %Client.accentColor;
		%Client.chestColor2 = %Client.chestColor;
		%Client.hipColor2 = %Client.hipColor;
		%Client.larmColor2 = %Client.larmColor;
		%Client.lhandColor2 = %Client.lhandColor;
		%Client.llegColor2 = %Client.llegColor;
		%Client.rarmColor2 = %Client.rarmColor;
		%Client.rhandColor2 = %Client.rhandColor;
		%Client.rlegColor2 = %Client.rlegColor;
}

function ClearChange(%Client)
{
	%Client.isFloatingHead = 0;
	%Client.isHorse = 0;
	%Client.isMonkey = 0;
	%Client.isSmurf = 0;
	%Client.isSkeleton = 0;
	%Client.isDog = 0;
	%Client.isPBear = 0;
}

function mRound(%Num)
{
	%NumPowered = %Num*mPow(10,2);
	%RoundedNum = mFloor(%NumPowered+0.5);
	%RoundedNum = %RoundedNum/mPow(10,2);
	return %RoundedNum;
}

function ExplodeTimeReset(%Client)
{
	%Client.explodefloodprotect = 0;
}

function FFCResizeMe(%Client,%Arg1,%Arg2,%Arg3)
{
	switch(isObject(%Client.player))
	{
		case 1:
			%Scale = %Client.player.getScale();
			%X = getWord(%Scale,0);
			%Y = getWord(%Scale,1);
			%Z = getWord(%Scale,2);
			if(%X < %Arg1){%X += 0.01;}
			if(%Y < %Arg2){%Y += 0.01;}
			if(%Z < %Arg3){%Z += 0.01;}
			if(%X > %Arg1){%X -= 0.01;}
			if(%Y > %Arg2){%Y -= 0.01;}
			if(%Z > %Arg3){%Z -= 0.01;}
			if(%X != %Arg1 || %Y != %Arg2 || %Z != %Arg3)
			{
				%Client.player.setScale(%X SPC %Y SPC %Z);
				%Client.ResizeEvnt = schedule(10,0,"FFCResizeMe",%Client,%Arg1,%Arg2,%Arg3);
				%Client.isResizing = 1;
			}
			else
			{
				cancel(%Client.ResizeEvnt);
				%Client.ResizeEvnt = 0;
				%Client.isResizing = 0;
			}
	}
}

function HideHeadNodes(%Player)
{
	%Player.hideNode("headSkin");
	%Player.unMountImage(2);
	for(%i=0;$accent[%i]	!$= "";%i++) %Player.hideNode($accent[%i]);
	for(%i=0;$hat[%i]	!$= "";%i++) %Player.hideNode($hat[%i]);
}

function ClearAllPlayerNodes(%Player)
{
	switch(isObject(%Player))
	{
		case 1:
			HideHeadNodes(%Player);
			%Player.hideNode("LSki");
			%Player.hideNode("RSki");
			%Player.hideNode("skirtTrimLeft");
			%Player.hideNode("skirtTrimRight");
			for(%i=0;%i		<5    ;%i++) %Player.unMountImage(%i);
			for(%i=0;$chest[%i]	!$= "";%i++) %Player.hideNode($chest[%i]);
			for(%i=0;$hip[%i]	!$= "";%i++) %Player.hideNode($hip[%i]);
			for(%i=0;$LArm[%i]	!$= "";%i++) %Player.hideNode($LArm[%i]);
			for(%i=0;$LHand[%i]	!$= "";%i++) %Player.hideNode($LHand[%i]);
			for(%i=0;$LLeg[%i]	!$= "";%i++) %Player.hideNode($LLeg[%i]);
			for(%i=0;$pack[%i]	!$= "";%i++) %Player.hideNode($pack[%i]);
			for(%i=0;$RArm[%i]	!$= "";%i++) %Player.hideNode($RArm[%i]);
			for(%i=0;$RHand[%i]	!$= "";%i++) %Player.hideNode($RHand[%i]);
			for(%i=0;$RLeg[%i]	!$= "";%i++) %Player.hideNode($RLeg[%i]);
			for(%i=0;$secondPack[%i]!$= "";%i++) %Player.hideNode($secondPack[%i]);
	}
}

function unHideHeadNodes(%Client)
{
	%Player = %Client.player;
	%Player.unHideNode("headSkin");
	%Player.setNodeColor("headSkin", %client.headColor);
	%Player.unHideNode($hat[%client.hat]);
	%Player.setNodeColor($hat[%client.hat], %client.hatColor);
	%Player.unHideNode("HeadSkin");
	%Player.unHideNode($Hat[%Client.hat]);
	if($accent[%Client.accent] !$= "none" && %Client.accent)
	{
		if(%Client.hat == 1){%Player.unHideNode($accent[4]);}
		else if(%Client.hat > 0){%Player.unHideNode($accent[%client.accent]);}
		%Player.setNodeColor($accent[%client.accent],%client.accentColor);
	}
}

function NormalMe(%Client)
{
	%Player = %Client.player;
	if(isObject(%Player))
	{
		%Minigame = %Client.minigame;
		if(%Minigame>0){%Player.setDataBlock(%Minigame.playerdatablock.getName());}
		else{%Player.setDataBlock("PlayerStandardArmor");}
		%Player.setShapeName(%Client.name);
		%Client.headcolor = %Client.headColor2;
		%Client.hatColor = %Client.hatColor2;
		%Client.accentColor = %Client.accentColor2;
		%Client.chestColor = %Client.chestColor2;
		%Client.hipColor = %Client.hipColor2;
		%Client.larmColor = %Client.larmColor2;
		%Client.lhandColor = %Client.lhandColor2;
		%Client.llegColor = %Client.llegColor2;
		%Client.rarmColor = %Client.rarmColor2;
		%Client.rhandColor = %Client.rhandColor2;
		%Client.rlegColor = %Client.rlegColor2;
		ClearChange(%Client);
		ClearAllPlayerNodes(%Player);
		unHideHeadNodes(%Client);
		if($pack[%client.pack] !$= "none" && %client.pack)
		{
			%Player.unHideNode($pack[%client.pack]);
			%Player.setNodeColor($pack[%client.pack], %client.packColor);
		}
		if($secondpack[%client.secondpack] !$= "none" && %client.secondpack)
		{
			%Player.unHideNode($secondpack[%client.secondpack]);
			%Player.setNodeColor($secondpack[%client.secondpack], %client.secondpackColor);
		}
		%Player.unHideNode($chest[%client.chest]);
		%Player.setNodeColor($chest[%client.chest], %client.chestColor);
		%Player.unHideNode($hip[%client.hip]);
		%Player.setNodeColor($hip[%client.hip], %client.hipColor);
		%Player.unHideNode($larm[%client.larm]);
		%Player.setNodeColor($larm[%client.larm], %client.larmColor);
		%Player.unHideNode($lhand[%client.lhand]);
		%Player.setNodeColor($lhand[%client.lhand], %client.lhandColor);
		%Player.unHideNode($lleg[%client.lleg]);
		%Player.setNodeColor($lleg[%client.lleg], %client.llegColor);
		%Player.unHideNode($rarm[%client.rarm]);
		%Player.setNodeColor($rarm[%client.rarm], %client.rarmColor);
		%Player.unHideNode($rhand[%client.rhand]);
		%Player.setNodeColor($rhand[%client.rhand], %client.rhandColor);
		%Player.unHideNode($rleg[%client.rleg]);
		%Player.setNodeColor($rleg[%client.rleg], %client.rlegColor);
		%Player.setFaceName(%client.faceName);
	}
}

function FFCConditionsCheck(%Client,%Victim,%Cmd,%Color)
{
	if(!isObject(%Client.player))
	{
		CenterPrint(%Client,"You can't do that while dead.",1,2);
		return 0;
	}
	else if(%Client.isResizing)
	{
		CenterPrint(%Client,"Please wait...",1,2);
		return 0;
	}
	else if(%Color !$= "" && %Color !$= "red" && %Color !$= "blue" && %Color !$= "green" && %Color !$= "yellow" && %Color !$= "orange" && %Color !$= "purple" && %Color !$= "pink" && %Color !$= "white" && %Color !$= "Black")
	{
		CenterPrint(%Client,"That color does not exsist.",1,2);
		return 0;
	}
	else if(%Cmd !$= "" && %Client.minigame>0)
	{
		switch$(%Cmd)
		{
			case "Normal":
				if(!%Client.minigame.Normal){CenterPrint(%Client,"That command is currently disabled.",1,2);return 0;}
			case "Monkey":
				if(!%Client.minigame.Monkey){CenterPrint(%Client,"That command is currently disabled.",1,2);return 0;}
			case "Skeleton":
				if(!%Client.minigame.Skeleton){CenterPrint(%Client,"That command is currently disabled.",1,2);return 0;}
			case "Smurf":
				if(!%Client.minigame.Smurf){CenterPrint(%Client,"That command is currently disabled.",1,2);return 0;}
			case "FloatingHead":
				if(!%Client.minigame.FloatingHead){CenterPrint(%Client,"That command is currently disabled.",1,2);return 0;}
			case "Cloak":
				if(!%Client.minigame.Cloak){CenterPrint(%Client,"That command is currently disabled.",1,2);return 0;}
			case "Horse":
				if(!%Client.minigame.Horse){CenterPrint(%Client,"That command is currently disabled.",1,2);return 0;}
			case "PlayDead":
				if(!%Client.minigame.PlayDead){CenterPrint(%Client,"That command is currently disabled.",1,2);return 0;}
			case "Resize":
				if(!%Client.minigame.Resize){CenterPrint(%Client,"That command is currently disabled.",1,2);return 0;}
			case "Dog":
				if(!%Client.minigame.Dog){CenterPrint(%Client,"That command is currently disabled.",1,2);return 0;}
		}
	}
	else if(%Victim)
	{
		if(%Client.minigame !$= %Victim.minigame && %Client.minigame>0 && %Victim.minigame>0)
		{
			CenterPrint(%Client,"You are not in the same minigame.",1,2);
			return 0;
		}
		else if(getTrustLevel(%Victim,%Client.player)<1)
		{
			CenterPrint(%Client,%Victim.name SPC "does not trust you enough to mount to him.",1,2);
			return 0;
		}
	}
	return 1;
}
